/*******************************************************************
HILBEX
version 0.1, 1 Oct 2016

This file is part of the software package Hilbex by Herman
Haverkort. Use and distribution of this software is subject to
restrictions. Consult readme.txt for details, or download it from
http://spacefillingcurves.net/.
*******************************************************************/

#ifndef HILBERT3DSUITE_BASEPATTERNS
#define HILBERT3DSUITE_BASEPATTERNS

class Partition
{
  public:
    char symbol;
    OPt pattern[4];
    string transformations;
    string permutations;
    Partition(const char c, const OPt& p0, const OPt& p1, const OPt& p2, const OPt& p3, const char* t, const char* p);
};

class Permutation
{
  private:
    int permut[4];
    int invper[4];
  public:
    char symbol;
    int operator()(const int i) const;
    int inv(const int i) const;
    Permutation(const char c, const int p0, const int p1, const int p2, const int p3);
};

class GateType
{
  private:
    NPt location;
  public:
    char symbol;
    bool facetGate() const;
    bool edgeGate() const;
    bool vertexGate() const;
    int operator[](const int i) const;
    GateType(const char c, const NPt& p);
};

vector<Partition> partitions;
vector<Permutation> permutations;
vector<GateType> gateTypes;

void initializeBasePatternTable();

#endif

